'use strict';

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

if (process.env.NODE_ENV === 'development') {
    try {
        var localVersion = require('./version.json');
        if (!localVersion._disable && fetch) {
            var server = 'http://alipay-rmsdeploy-image.cn-hangzhou.alipay.aliyun-inc.com';
            fetch(server + '/filesync/prod/z/fengdie/antd-mobile-upgrade-tip/upgrade-tip-h5data.json').then(function (data) {
                return data.json();
            }).then(function (data) {
                var notice = '';
                var tipComponents = data.filter(function (item) {
                    var key = item.name;
                    if (key === '[notice]') {
                        notice = item.tip;
                    }
                    if (!localVersion[key]) {
                        return false;
                    }
                    var oldVer = localVersion[key].split('.');
                    var newVer = item.version.split('.');
                    var result = false;
                    var length = Math.max(oldVer.length, newVer.length);
                    for (var i = 0; i < length; i++) {
                        if (oldVer[i] !== newVer[i]) {
                            result = result || oldVer[i] === undefined || oldVer[i] < newVer[i];
                        }
                    }
                    return result;
                });
                if (notice) {
                    console.warn('--------------------------------------------------------\n', '[antd-mobile-upgrade-tip] Notice:\n', notice + '\n', '--------------------------------------------------------');
                }
                if (tipComponents.length > 0) {
                    var _console;

                    (_console = console).warn.apply(_console, ['--------------------------------------------------------\n', '[antd-mobile-upgrade-tip] some components is expired:\n', '\n'].concat((0, _toConsumableArray3['default'])(tipComponents.map(function (newData) {
                        var key = newData.name;
                        return key + ': ' + localVersion[key] + ' => ' + newData.version + ' ' + newData.tip + ' ' + newData.url + '\n';
                    })), ['\n', '[you can reinstall node_modules to upgrade all of them.]\n', '[about this] http://beta.mobile.ant.design/docs/react/upgrade-tip-cn\n', '--------------------------------------------------------']));
                }
            })['catch'](function () {});
        }
    } catch (error) {}
}